/*
    JSXGraph 0.97.0

    Copyright 2008-2013
        Matthias Ehmann,
        Michael Gerhaeuser,
        Carsten Miller,
        Bianca Valentin,
        Alfred Wassermann,
        Peter Wilfahrt

    This file is part of JSXGraph.

    JSXGraph is free software dual licensed under the GNU LGPL or MIT License.

    You can redistribute it and/or modify it under the terms of the

      * GNU Lesser General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version
      OR
      * MIT License: https://github.com/jsxgraph/jsxgraph/blob/master/LICENSE.MIT

    JSXGraph is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License and
    the MIT License along with JSXGraph. If not, see <http://www.gnu.org/licenses/>
    and <http://opensource.org/licenses/MIT/>.
*/

/**
 * almond 0.2.5 Copyright (c) 2011-2012, The Dojo Foundation All Rights Reserved.
 * Available via the MIT or new BSD license.
 * see: http://github.com/jrburke/almond for details
 */

/**
 * UTF-8 Decoder by Bjoern Hoehrmann
 *
 * Copyright (c) 2008-2009 Bjoern Hoehrmann <bjoern@hoehrmann.de>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
/*
    Copyright 2008-2013
        Matthias Ehmann,
        Michael Gerhaeuser,
        Carsten Miller,
        Bianca Valentin,
        Alfred Wassermann,
        Peter Wilfahrt

    This file is part of JSXGraph.

    JSXGraph is free software dual licensed under the GNU LGPL or MIT License.
    
    You can redistribute it and/or modify it under the terms of the
    
      * GNU Lesser General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version
      OR
      * MIT License: https://github.com/jsxgraph/jsxgraph/blob/master/LICENSE.MIT
    
    JSXGraph is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.
    
    You should have received a copy of the GNU Lesser General Public License and
    the MIT License along with JSXGraph. If not, see <http://www.gnu.org/licenses/>
    and <http://opensource.org/licenses/MIT/>.
 *//*global JXG: true*//*jslint nomen: true, plusplus: true*//* depends:
 jxg
 math/math
 utils/encoding
 utils/zip
 utils/type
 utils/base64
 utils/xml
  elements:
   point
   line
   conic
   parallel
   perpendicular
   intersection
   otherintersection
   glider
   bisector
   midpoint
   circumcircle
   tangent
   circle
   bisectorlines
   polygon
   arrow
 */(function(){"use strict";JXG.IntergeoReader=function(e,t){var n;this.board=e,n=this.prepareString(t),this.tree=JXG.XML.parse(n)},JXG.extend(JXG.IntergeoReader.prototype,{objects:{},read:function(){this.board.origin={},this.board.origin.usrCoords=[1,0,0],this.board.origin.scrCoords=[1,400,300],this.board.unitX=30,this.board.unitY=30,this.readElements(this.tree.getElementsByTagName("elements")),this.readConstraints(this.tree.getElementsByTagName("constraints")),this.cleanUp(),this.board.fullUpdate(),this.readDisplay(this.tree.getElementsByTagName("display")),this.board.fullUpdate()},readElement:function(e,t){var n;n=e[0].childNodes[t];if(n.nodeType>1)return;n.nodeName==="point"?this.storePoint(n):n.nodeName==="line"||n.nodeName==="line_segment"||n.nodeName==="ray"||n.nodeName==="vector"?this.storeLine(n):n.nodeName==="circle"?this.storeConic(n):n.nodeName==="conic"?this.storeConic(n):JXG.debug("Not implemented: "+n.nodeName+" "+n.getAttribute("id"))},readElements:function(e){var t;for(t=0;t<e[0].childNodes.length;t++)this.readElement(e,t)},storePoint:function(e){var t=0,n=0,r=0,i=e.childNodes[t],s=[],o=[];while(i.nodeType>1)t+=1,i=e.childNodes[t];if(i.nodeName==="homogeneous_coordinates"){for(n=0;n<i.childNodes.length;n++)if(i.childNodes[n].nodeType===1)if(i.childNodes[n].nodeName==="double")s.push(i.childNodes[n].firstChild.data);else{if(i.childNodes[n].nodeName!=="complex"){JXG.debug("Not implemented: "+i.childNodes[n].nodeName);return}for(r=0;r<i.childNodes[n].childNodes.length;r++)i.childNodes[n].childNodes[r].nodeName==="double"&&s.push(i.childNodes[n].childNodes[r].firstChild.data)}for(n=0;n<s.length;n++)s[n]=parseFloat(s[n]);if(s.length===3)o=[s[2],s[0],s[1]];else{if(!(s.length===6&&Math.abs(s[1])<1e-10&&Math.abs(s[3])<1e-10&&Math.abs(s[5])<1e-10)){JXG.debug("type not supported, yet");return}o=[s[4],s[0],s[2]]}}else if(i.nodeName==="euclidean_coordinates"||i.nodeName==="euclidian_coordinates"){for(n=0;n<i.childNodes.length;n++)i.childNodes[n].nodeType===1&&s.push(i.childNodes[n].firstChild.data);for(n=0;n<s.length;n++)s[n]=parseFloat(s[n]);o=[s[0],s[1]]}else{if(i.nodeName!=="polar_coordinates"){JXG.debug("This coordinate type is not yet implemented: "+i.nodeName);return}for(n=0;n<i.childNodes.length;n++)i.childNodes[n].nodeType===1&&s.push(i.childNodes[n].firstChild.data);for(n=0;n<s.length;n++)s[n]=parseFloat(s[n]);o=[s[0]*Math.cos(s[1]),s[0]*Math.sin(s[1])]}this.objects[e.getAttribute("id")]={id:e.getAttribute("id"),coords:null},this.objects[e.getAttribute("id")].coords=o,this.objects[e.getAttribute("id")].id=e.getAttribute("id"),this.objects[e.getAttribute("id")].exists=!1,this.objects[e.getAttribute("id")].i2geoType="point"},storeLine:function(e){var t,n,r,i;this.objects[e.getAttribute("id")]={id:e.getAttribute("id"),coords:null},t=0,n=e.childNodes[t];while(n.nodeType>1)t+=1,n=e.childNodes[t];if(n.nodeName==="homogeneous_coordinates"){r=[];for(i=0;i<n.childNodes.length;i++)n.childNodes[i].nodeType===1&&n.childNodes[i].nodeName==="double"&&r.push(parseFloat(n.childNodes[i].firstChild.data));this.objects[e.getAttribute("id")].coords=r,this.objects[e.getAttribute("id")].id=e.getAttribute("id"),this.objects[e.getAttribute("id")].exists=!1,this.objects[e.getAttribute("id")].i2geoType="line"}},storeConic:function(e){var t,n,r,i;this.objects[e.getAttribute("id")]={id:e.getAttribute("id"),coords:null},t=0,r=e.childNodes[t];while(r.nodeType>1)t+=1,r=e.childNodes[t];if(r.nodeName==="matrix"){i=[];for(n=0;n<r.childNodes.length;n++)r.childNodes[n].nodeType===1&&r.childNodes[n].nodeName==="double"&&i.push(parseFloat(r.childNodes[n].firstChild.data));this.objects[e.getAttribute("id")].coords=i,this.objects[e.getAttribute("id")].id=e.getAttribute("id"),this.objects[e.getAttribute("id")].exists=!1,this.objects[e.getAttribute("id")].i2geoType="conic"}},readConstraint:function(e,t){var n,r;r=e[0].childNodes[t];if(r.nodeType>1)return;r.nodeName==="line_through_two_points"?this.addLineThroughTwoPoints(r,!1):r.nodeName==="ray_from_point_through_point"?this.addLineThroughTwoPoints(r,!0):r.nodeName==="line_through_point"?this.addLineThroughPoint(r):r.nodeName==="line_parallel_to_line_through_point"?this.addLineParallelToLineThroughPoint(r,!1):r.nodeName==="ray_from_point_and_vector"?this.addLineParallelToLineThroughPoint(r,!0):r.nodeName==="line_perpendicular_to_line_through_point"?this.addLinePerpendicularToLineThroughPoint(r):r.nodeName==="line_segment_by_points"?this.addLineSegmentByTwoPoints(r):r.nodeName==="vector_from_point_to_point"?this.addVectorFromPointToPoint(r):r.nodeName==="endpoints_of_line_segment"?this.addEndpointsOfLineSegment(r):r.nodeName==="free_line"?this.addFreeLine(r):r.nodeName==="point_on_line"?this.addPointOnLine(r):r.nodeName==="point_on_line_segment"?this.addPointOnLine(r):r.nodeName==="point_on_circle"?this.addPointOnCircle(r):r.nodeName==="angular_bisector_of_three_points"?this.addAngularBisectorOfThreePoints(r,!1):r.nodeName==="angular_bisectors_of_two_lines"?this.addAngularBisectorsOfTwoLines(r):r.nodeName==="line_angular_bisector_of_three_points"?this.addAngularBisectorOfThreePoints(r,!0):r.nodeName==="line_angular_bisectors_of_two_lines"?this.addAngularBisectorsOfTwoLines(r):r.nodeName==="midpoint_of_two_points"?this.addMidpointOfTwoPoints(r):r.nodeName==="midpoint"?this.addMidpointOfTwoPoints(r):r.nodeName==="midpoint_of_line_segment"||r.nodeName==="midpoint_line_segment"?this.addMidpointOfLineSegment(r):r.nodeName==="point_intersection_of_two_lines"?this.addPointIntersectionOfTwoLines(r):r.nodeName==="locus_defined_by_point"?this.addLocusDefinedByPoint(r):r.nodeName==="locus_defined_by_point_on_line"?this.addLocusDefinedByPointOnLine(r):r.nodeName==="locus_defined_by_point_on_line_segment"?this.addLocusDefinedByPointOnLine(r):r.nodeName==="locus_defined_by_line_through_point"?this.addLocusDefinedByLineThroughPoint(r):r.nodeName==="locus_defined_by_point_on_circle"?this.addLocusDefinedByPointOnCircle(r):r.nodeName==="circle_by_three_points"?this.addCircleByThreePoints(r):r.nodeName==="circle_by_center_and_point"?this.addCircleByCenterAndPoint(r):r.nodeName==="center_of_circle"?this.addCenterOfCircle(r):r.nodeName==="intersection_points_of_two_circles"?this.addIntersectionPointsOfTwoCircles(r):r.nodeName==="intersection_points_of_circle_and_line"?this.addIntersectionPointsOfCircleAndLine(r):r.nodeName==="other_intersection_point_of_two_circles"?this.addOtherIntersectionPointOfTwoCircles(r):r.nodeName==="other_intersection_point_of_circle_and_line"?this.addOtherIntersectionPointOfCircleAndLine(r):r.nodeName==="circle_tangent_lines_by_point"?this.addCircleTangentLinesByPoint(r):r.nodeName==="polygon_by_vertices"?this.addPolygonByVertices(r):(n=this.readParams(r),JXG.debug("readConstraints: not implemented: "+r.nodeName+": "+n[0]))},readConstraints:function(e){var t;this.board.options.point.strokeColor="blue",this.board.options.point.fillColor="blue";for(t=0;t<e[0].childNodes.length;t++)this.readConstraint(e,t)},setAttributes:function(e){e.setProperty({strokecolor:this.board.options.point.strokeColor,fillColor:this.board.options.point.fillColor})},readParams:function(e){var t,n=[];for(t=0;t<e.childNodes.length;t++)e.childNodes[t].nodeType===1&&n.push(e.childNodes[t].firstChild.data);return n},addPoint:function(e){return e.exists||(e.exists=!0,e=this.board.create("point",e.coords,{name:e.id}),e.setProperty({strokecolor:"red",fillColor:"red"})),e},addLine:function(e){var t,n=this.objects[e].coords,r;for(t=0;t<n.length;t++)n[t]=parseFloat(n[t]);r=this.board.create("line",[n[2],n[0],n[1]],{name:e,strokeColor:"black",withLabel:!0}),this.objects[e]=r},addConic:function(e){var t;return e.exists||(t=e.coords,e=this.board.create("conic",[t[0],t[4],t[8],t[1],t[5],t[2]],{name:e.id}),e.exists=!0),e},cleanUp:function(){var e;for(e in this.objects)this.objects.hasOwnProperty(e)&&this.objects[e].exists===!1&&(this.objects[e].i2geoType==="point"?this.addPoint(this.objects[e]):this.objects[e].i2geoType==="line"?this.addLine(this.objects[e]):this.objects[e].i2geoType==="conic"?this.addConic(this.objects[e]):JXG.debug("forgotten: "+this.objects[e].id+" of type "+this.objects[e].i2geoType))},addLineThroughTwoPoints:function(e,t){var n,r,i,s=this.readParams(e);n=this.addPoint(this.objects[s[1]]),r=this.addPoint(this.objects[s[2]]),i=this.board.create("line",[n.id,r.id],{name:s[0],withLabel:!0,straightFirst:!t,straightLast:!0}),this.objects[s[0]]=i,this.objects[s[0]].exists=!0},addLineThroughPoint:function(e){var t=this.readParams(e),n,r=this.objects[t[0]].coords,i=this.addPoint(this.objects[t[1]]),s;for(n=0;n<r.length;n++)r[n]=parseFloat(r[n]);s=this.board.create("line",[function(){return r[2]-r[0]*i.X()-r[1]*i.Y()-r[2]*i.Z()},r[0],r[1]],{name:t[0],strokeColor:"black",withLabel:!0}),this.objects[t[0]]=s,this.objects[t[0]].exists=!0},addLineParallelToLineThroughPoint:function(e,t){var n,r,i,s=this.readParams(e);n=this.addPoint(this.objects[s[1]]),r=this.addPoint(this.objects[s[2]]),i=this.board.create("parallel",[n.id,r.id],{name:s[0],withLabel:!0,straightFirst:!t,straightLast:!0}),this.objects[s[0]]=i,this.objects[s[0]].exists=!0},addLinePerpendicularToLineThroughPoint:function(e){var t,n,r,i=this.readParams(e);t=this.addPoint(this.objects[i[1]]),n=this.addPoint(this.objects[i[2]]),r=this.board.create("perpendicular",[t.id,n.id],{name:i[0],id:i[0],straightFirst:!0,straightLast:!0,point:{name:i[0]+"foot",id:i[0]+"foot"},withLabel:!0}),this.objects[i[0]]=r,this.objects[i[0]].exists=!0},addLineSegmentByTwoPoints:function(e){var t,n,r,i=this.readParams(e);t=this.addPoint(this.objects[i[1]]),n=this.addPoint(this.objects[i[2]]),r=this.board.create("line",[t.id,n.id],{name:i[0],straightFirst:!1,straightLast:!1,strokeColor:"black",withLabel:!0}),this.objects[i[0]]=r,this.objects[i[0]].exists=!0},addPointIntersectionOfTwoLines:function(e){var t=this.readParams(e),n=this.objects[t[1]],r=this.objects[t[2]];this.objects[t[0]]=this.board.create("intersection",[n,r,0],{name:t[0],id:t[0],withLabel:!0}),this.setAttributes(this.objects[t[0]]),this.objects[t[0]].exists=!0},addFreeLine:function(e){var t=this.readParams(e),n=this.objects[t[0]].coords[0],r=this.objects[t[0]].coords[1],i=this.objects[t[0]].coords[2],s=this.board.create("line",[i,n,r],{name:t[0],id:t[0],withLabel:!0});this.objects[t[0]]=s,this.objects[t[0]].exists=!0},addPointOnLine:function(e){var t=this.readParams(e),n=this.board.select(t[1]);this.board.create("glider",[0,0,n],{name:t[0],id:t[0],withLabel:!0}),this.objects[t[0]].exists=!0},addPointOnCircle:function(e){var t=this.readParams(e),n=this.board.select(t[1]);n.update(),this.board.create("glider",[this.objects[t[0]].coords[1],this.objects[t[0]].coords[2],n],{name:t[0],id:t[0],withLabel:!0}),this.objects[t[0]].exists=!0},addEndpointsOfLineSegment:function(e){var t=this.readParams(e),n=this.objects[t[2]],r=this.addPoint(this.objects[t[0]]),i=this.addPoint(this.objects[t[1]]);r.addConstraint([function(){return n.point1.Z()},function(){return n.point1.X()},function(){return n.point1.Y()}]),i.addConstraint([function(){return n.point2.Z()},function(){return n.point2.X()},function(){return n.point2.Y()}]),this.setAttributes(r),this.setAttributes(i)},addAngularBisectorOfThreePoints:function(e,t){var n,r,i,s,o=this.readParams(e);n=this.addPoint(this.objects[o[1]]),r=this.addPoint(this.objects[o[2]]),i=this.addPoint(this.objects[o[3]]),s=this.board.create("bisector",[n.id,r.id,i.id],{name:o[0],id:o[0],withLabel:!0,straightFirst:t,straightLast:!0,strokeColor:"#000000"}),this.objects[o[0]]=s,this.objects[o[0]].exists=!0},addMidpointOfTwoPoints:function(e){var t,n,r,i=this.readParams(e);t=this.addPoint(this.objects[i[1]]),n=this.addPoint(this.objects[i[2]]),r=this.board.create("midpoint",[t.id,n.id],{name:i[0]}),this.setAttributes(r),this.objects[i[0]].exists=!0},addMidpointOfLineSegment:function(e){var t=this.readParams(e),n=this.board.select(t[1]),r=this.board.create("midpoint",[n.point1,n.point2],{name:t[0]});this.setAttributes(r),this.objects[t[0]].exists=!0},addCircleByThreePoints:function(e){var t,n=this.readParams(e),r=[];for(t=0;t<3;t++)r[t]=this.addPoint(this.objects[n[t+1]]);this.board.create("circumcircle",r,{name:n[0],id:n[0],point:{name:n[0]+"c",id:n[0]+"c"},withLabel:!0}),this.objects[n[0]].exists=!0},addCenterOfCircle:function(e){var t=this.readParams(e),n=this.board.select(t[1]),r=this.board.create("point",[function(){return n.center.X()},function(){return n.center.Y()}],{name:t[0],id:t[0],withLabel:!0});this.setAttributes(r),this.objects[t[0]].exists=!0},addCircleTangentLinesByPoint:function(e){var t,n,r,i,s,o=this.readParams(e),u=this.board.select(o[2]),a=this.addPoint(this.objects[o[3]]);t=this.board.create("line",[function(){return JXG.Math.matVecMult(u.quadraticform,a.coords.usrCoords)[0]},function(){return JXG.Math.matVecMult(u.quadraticform,a.coords.usrCoords)[1]},function(){return JXG.Math.matVecMult(u.quadraticform,a.coords.usrCoords)[2]}],{visible:!1}),n=this.board.create("intersection",[u,t,0],{visible:!1}),r=this.board.create("intersection",[u,t,1],{visible:!1}),i=this.board.create("tangent",[n,u]),s=this.board.create("tangent",[r,u]),this.objects[o[0]]=i,this.objects[o[1]]=s,this.objects[o[0]].exists=!0,this.objects[o[1]].exists=!0},addIntersectionPointsOfTwoCircles:function(e){var t,n,r=this.readParams(e),i=this.board.select(r[2]),s=this.board.select(r[3]);t=this.board.create("intersection",[i,s,0],{name:r[0],id:r[0],withLabel:!0}),n=this.board.create("intersection",[i,s,1],{name:r[1],id:r[1],withLabel:!0}),this.setAttributes(t),this.setAttributes(n),this.objects[r[0]].exists=!0,this.objects[r[1]].exists=!0},addIntersectionPointsOfCircleAndLine:function(e){var t,n,r=this.readParams(e),i=this.board.select(r[2]),s=this.board.select(r[3]);t=this.board.create("intersection",[i,s,0],{name:r[0],id:r[0],withLabel:!0}),n=this.board.create("intersection",[i,s,1],{name:r[1],id:r[1],withLabel:!0}),this.setAttributes(t),this.setAttributes(n),this.objects[r[0]].exists=!0,this.objects[r[1]].exists=!0},addCircleByCenterAndPoint:function(e){var t=this.readParams(e),n=this.addPoint(this.objects[t[1]]),r=this.addPoint(this.objects[t[2]]);this.board.create("circle",[n.id,r.id],{name:t[0],id:t[0],withLabel:!0}),this.objects[t[0]].exists=!0},addOtherIntersectionPointOfTwoCircles:function(e){var t=this.readParams(e),n=this.board.select(t[2]),r=this.board.select(t[3]),i=this.board.select(t[1]),s;s=this.board.create("otherintersection",[n,r,i],{name:t[0],id:t[0],withLabel:!0}),this.setAttributes(s),this.objects[t[0]].exists=!0},addOtherIntersectionPointOfCircleAndLine:function(e){this.addOtherIntersectionPointOfTwoCircles(e)},addAngularBisectorsOfTwoLines:function(e){var t=this.readParams(e),n=this.objects[t[2]],r=this.objects[t[3]];this.board.create("bisectorlines",[n,r],{line1:{name:t[0],id:t[0],straightFirst:!0,straightLast:!0},line2:{name:t[1],id:t[1],straightFirst:!0,straightLast:!0},withLabel:!0}),this.objects[t[0]].exists=!0,this.objects[t[1]].exists=!0},addPolygonByVertices:function(e){var t,n,r=[],i=[],s=this.readParams(e);for(t=0;t<e.childNodes.length;t++)if(e.childNodes[t].nodeType===1&&e.childNodes[t].nodeName==="list_of_vertices"){n=e.childNodes[t],r=this.readParams(n);break}for(t=0;t<r.length;t++)i.push(this.addPoint(this.objects[r[t]]));this.board.create("polygon",i,{name:s[0],id:s[0],withLabel:!0}),this.objects[s[0]].exists=!0},addVectorFromPointToPoint:function(e){var t,n,r,i=this.readParams(e);n=this.addPoint(this.objects[i[1]]),r=this.addPoint(this.objects[i[2]]),t=this.board.create("arrow",[n.id,r.id],{name:i[0]}),this.setAttributes(t),this.objects[i[0]].exists=!0},addLocusDefinedByPoint:function(e){var t=this.readParams(e),n=this.board.select(t[1]);n.setProperty({trace:!0}),this.objects[t[1]]=n,this.setAttributes(n)},addLocusDefinedByPointOnLine:function(e){var t=this.readParams(e),n=this.board.select(t[1]);n.setProperty({trace:!0}),this.objects[t[1]]=n,this.setAttributes(n)},addLocusDefinedByLineThroughPoint:function(e){var t=this.readParams(e),n=this.board.select(t[1]);n.setProperty({trace:!0}),this.objects[t[1]]=n,this.setAttributes(n)},addLocusDefinedByPointOnCircle:function(e){var t=this.readParams(e),n=this.board.select(t[1]);n.setProperty({trace:!0}),this.objects[t[1]]=n,this.setAttributes(n)},prepareString:function(e){var t,n=[],r=!1;if(e.slice(0,2)==="PK"||JXG.Util.UTF8.asciiCharCodeAt(e.slice(0,1),0)===31)r=!0;!r&&e.indexOf("<")!==0&&(e=JXG.Util.Base64.decode(e));if(e.indexOf("<")!==0){for(t=0;t<e.length;t++)n[t]=JXG.Util.UTF8.asciiCharCodeAt(e,t);e=(new JXG.Util.Unzip(n)).unzipFile("construction/intergeo.xml")}return e},readDisplayProperty:function(e,t){var n,r,i,s={},o,u;r=e[0].childNodes[t];if(r.nodeType>1)return;if(r.nodeName==="background-color")this.board.containerObj.style.backgroundColor=r.firstChild.data;else if(r.nodeName==="style"){i=this.board.select(r.getAttribute("ref"));for(n=0;n<r.childNodes.length;n++)r.childNodes[n].nodeType===1&&(o=r.childNodes[n].nodeName,u=r.childNodes[n].firstChild.data,o==="stroke"?o="strokeColor":o==="stroke-width"||o==="border-width"?o="strokeWidth":o==="fill"?o="fillColor":o==="fill-opacity"?o="fillOpacity":o==="border-opacity"?o="strokeOpacity":o==="point-size"?o="size":o==="label"?o="name":o==="point-style"&&(o="face",u==="circle"?u="o":u==="cross"?u="+":u==="x-mark"?u="x":u==="square"?u="[]":u==="triangle"?u="triangleup":u==="point"?u="o":JXG.debug("Display: not implemented"+r.nodeName)),s[o]=u);i.setProperty(s)}else JXG.debug("Display: not implemented"+r.nodeName)},readDisplay:function(e){var t;if(!JXG.exists(e)||!JXG.isArray(e))return;for(t=0;t<e[0].childNodes.length;t++)this.readDisplayProperty(e,t)}}),JXG.registerReader(JXG.IntergeoReader,["i2g","xml","intergeo"])})();